//
//  ivr4pengine_h
//  MyTest4
//
//  Created by 孙桂山 on 2017/12/10.
//  Copyright © 2017年 孙桂山. All rights reserved.
//

#ifndef ivr4pengine_h
#define ivr4pengine_h

#include <stdio.h>

#if defined(__cplusplus)
extern "C"
{
#endif
    

    bool  V4_RegLicense(const char * strLicenseID, const char * strKey);

    bool  V4_HaveLicense(void);

    bool  V4_HaveLicenseCurFile(void);

    long  V4_GetVersionID(void);

    long  V4_InitVR4P(const char * strFolder);

    void  V4_UninitVR4P(void);

    bool  V4_Is3DVRF(const char * strSourceName);

    long  V4_GetResolution(void);

    long  V4_GetResolutionF(const char * strSourceName);

    long  V4_GetMaxPosF(const char * strSourceName);

    long  V4_PlayVRV(const char * strSourceName,const char * strIP,int iPort, bool bLooping, const char * strUserIDOrOtherInfo);
    
    long  V4_SvrVrvState(void);

    long  V4_GetAudioType(void);

    bool  V4_Is3DVR(void);

    void  V4_StopVRV(void);

    bool  V4_IsPlaying(void);

    void  V4_PauseVRV(bool bPlay);

    void  V4_ResizeMyGL(int width, int height);


#define  g_iRenderScene_NoGlass  0
#define  g_iRenderScene_VRLeft   1
#define  g_iRenderScene_VRRight  2
    bool   V4_RenderScene(int iType);

    void   V4_PreRender(void);
    
    void   V4_AftRender(void);
    
    void   V4_ReleaseGLRes(void);

    void   V4_ResetGLRes(void);

    void   V4_SeekPos(long lTimeValue, int iLab);

    long   V4_GetPos(void);

    long   V4_GetMaxPos(void);

    float  V4_GetRotateAngle(void);

    void   V4_SetRotateAngle(float fYawAngle);

    float  V4_ComputeYawAngle(float fx1, float fy1, float fx2, float fy2);

#define  g_iDirType_Font   0
#define  g_iDirType_Back   1
#define  g_iDirType_Right  2
#define  g_iDirType_Left   3
#define  g_iDirType_Up     4
#define  g_iDirType_Down   5
#define  g_iDirType_Camera 6

    void   V4_GetDir(int iType, float fResultDir[3]);

    bool   V4_Render3DUI(bool bLeftEye, float fEyeOffset, float f3DRectPos[12], bool bOpacity, int iTextureHandle);
    
    bool   V4_Render3DUI2(bool bLeftEye, float fEyeOffset, float f3CenterPos[3], bool bVertical, float fWidth, float fHeight, float fRotateAngle, bool bOpacity, int iTextureHandle);
    
    bool   V4_Render3DProgressCircle(bool bLeftEye, float fEyeOffset, float f3CenterPos[3], bool bVertical, float fWidth, float fRotateAngle, int iTextureHandle);
    
    bool   V4_Render2DUI(float fCenterXInP, float fCenterYInP, float fWidthInP, float fHeightInP,float fRotateAngle, bool bOpacity, int iTextureHandle);
    
    void   V4_CfgSetCenterBlackWidth(int iWidth);

    int    V4_CfgGetCenterBlackWidth(void);

    void   V4_CfgSetGlassMode(bool bGlassMode);

    bool   V4_CfgGetGlassMode(void);

    void   V4_CfgSetGlassViewPortType(long lType);

    long   V4_CfgGetGlassViewPortType(void);

    void   V4_CfgSetGlassViewPortScale(float fScale);

    float  V4_CfgGetGlassViewPortScale(void);

    void   V4_CfgSetCenterOffset(int iOffsetH, int iOffsetV);

    int    V4_CfgGetCenterOffsetH(void);

    int    V4_CfgGetCenterOffsetV(void);
    
    int    V4_CfgComCenterOffsetVByPupiDis(float fPupiDis, float fScreenSize);
    
    void   V4_CfgSetGlassViewPortRotate(int iRotateType);
    
    int    V4_CfgGetGlassViewPortRotate();

    void   V4_CfgSetFovV(float fFovV);

    float  V4_CfgGetFovV(void);

    void   V4_CfgSetUndistortParam(float Undistort1, float Undistort2);

    float  V4_CfgGetUndistortParam1(void);

    float  V4_CfgGetUndistortParam2(void);
    
#define  g_iRenderFPS_60   0
#define  g_iRenderFPS_75   1
#define  g_iRenderFPS_90   2
#define  g_iRenderFPS_120  3
    void   V4_SetRenderFPSForOP(int iRenderFPS);
    
    void   V4_CfgSetVolume(float fParam);
    
    float  V4_CfgGetVolume();
    
#if defined(__cplusplus)
}
#endif

#endif






