//
//  AppDelegate.m
//  MyTest4
//
//  Created by 孙桂山 on 2017/12/5.
//  Copyright © 2017年 孙桂山. All rights reserved.
//

#import "AppDelegate.h"
#import "ivr4pengine.h"
#import "StatusBarUpdate.h"


@interface AppDelegate ()

@end

@implementation AppDelegate


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    UpdateStatusBar([[UIApplication sharedApplication] statusBarOrientation]);
    NSArray *  paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask,YES);
    NSString * pstrPath = [paths  objectAtIndex:(0)];
    const char * pFolder = NULL;
    if(pstrPath)
    {
        pFolder = [pstrPath UTF8String];
        NSLog(@"pFolder=%s",pFolder);
    }
    V4_InitVR4P(pFolder);
    V4_RegLicense("660001201710120001","");
    return YES;
}




- (void)applicationWillResignActive:(UIApplication *)application
{
    V4_ReleaseGLRes();
    [[UIApplication sharedApplication] setIdleTimerDisabled:(NO)];
}


- (void)applicationDidEnterBackground:(UIApplication *)application
{
}


- (void)applicationWillEnterForeground:(UIApplication *)application
{
}


- (void)applicationDidBecomeActive:(UIApplication *)application
{
    [[UIApplication sharedApplication] setIdleTimerDisabled:(YES)];
    V4_ResetGLRes();
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    V4_UninitVR4P();
}

- (void)application:(UIApplication*)application didChangeStatusBarOrientation:(UIInterfaceOrientation)oldStatusBarOrientation
{
    UpdateStatusBar([[UIApplication sharedApplication] statusBarOrientation]);
}



@end



